<?php
namespace Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification; 

class Ger80200ApuracaoConsumoController extends \Teknisa\Libs\Controller\CRUD{

    protected $dataSourceManager;
    protected $connection;
    protected $environment;
    
    public function __construct($crudService, $environment ,$connection) {
        parent::__construct($crudService, $environment);
        $this->connection  = $connection;
        $this->environment = $environment;
        
    }
    
   public function checkServico (DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        $filtro = array(
            array(
                "columnName" => "CDORDEM",
                "operator" => "=",
                "value" => $rows[0]["CDORDEM"]
            ),
            array(
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $rows[0]["CDFILIAL"]
            ),
            array(
                "columnName" => "IDDETALHESERVICO",
                "operator" => "=",
                "value" => "RETIRADA"
            )
        );
        $dataSet = $this->crudService->getFilteredDataSet('detalhe_servicorop', $filtro)->getRows();
        $retorno = true;
        if(!empty($dataSet)){
            if($dataSet[0]["CDSERVFILI"] != $rows[0]["CDSERVFILI"]){
                $retorno = false;
            }
        }else{
            
        }
        $response->addDataSet(new DataSet("RETORNO", [$retorno]));
    }
     
}