<?php
namespace Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class Ger80200Replicar extends \Teknisa\Libs\Controller\CRUD {
    
    protected $environment;
    protected $connection;
    protected $crudService;
    protected $service;
    protected $newCode;
    protected $entityManager;
    
    public function __construct($crudService, $environment, $connection,$entityManager,$newCode,$service) {
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->newCode = $newCode;
        $this->service = $service;
        parent::__construct($crudService, $environment);
        
    }
    
    public function replicar(DTO\Request $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows()[0];
        $colunas = 'CDOPERULTATU, NRORG';
        $colunasin = 'PA.CDOPERULTATU, PA.NRORG';
        $nrlistaUnidade;
        try{
            
            if( $rows['FILIAL_DESTINO'] != 'T' && $rows['FILIAL_DESTINO'] != '' ){
                
                $nrlistaUnidade = $this->criarListaValores(implode('_', $rows['FILIAL_DESTINO']));
            }else {
                 $nrlistaUnidade = 'T';
            }
            
            if($nrlistaUnidade != 'T'){
                $nrlistaUnidade = str_replace('_NRLISTA=', '', $nrlistaUnidade);
                $params = array(
                        "P_CDFILIAL" => $rows['CDFILIAL'],
                        "P_NRLISTA" => $nrlistaUnidade,
                        "P_CDOPERULTATU" => $this->environment->getCdOperador()
                    ); 
               
            }else{
                 $params = array(
                        "P_CDFILIAL" => $rows['CDFILIAL'],
                        "P_CDOPERADOR" => $this->environment->getCdOperador(),
                        "P_CDOPERULTATU" => $this->environment->getCdOperador()
                    );
               
            }    
                
            foreach($rows["Pagina_Replicada"] as $pagina){
                if($pagina == "GERAL"){
                    if( $rows['CDFILIAL'] != 'P'){
                        $colunasin = $colunasin.",
                        PA.IDUTPADRROPFIL,
                        PA.IDFILIALAGRROP,
                        PA.IDCOMPARANFEFET,
                        PA.CDTPOPTRANSFIL,
                        PA.IDTPAPURACAO,
                        PA.IDPROJECMANU,
                        PA.IDVOLUNEGOCIO,
                        PA.CDGRUPPROD";
                        $colunas = $colunas.",
                        IDUTPADRROPFIL,
                        IDFILIALAGRROP,
                        IDCOMPARANFEFET,
                        CDTPOPTRANSFIL,
                        IDTPAPURACAO,
                        IDPROJECMANU,
                        IDVOLUNEGOCIO,
                        CDGRUPPROD";  
                    }
                    else{
                        $colunasin = $colunasin.",
                        PA.IDFILIALAGRROP,
                        PA.IDCOMPARANFEFET,
                        PA.CDTPOPTRANSFIL,
                        PA.IDTPAPURACAO,
                        PA.IDPROJECMANU,
                        PA.IDVOLUNEGOCIO,
                        PA.CDGRUPPROD";
                        $colunas = $colunas.",
                        IDFILIALAGRROP,
                        IDCOMPARANFEFET,
                        CDTPOPTRANSFIL,
                        IDTPAPURACAO,
                        IDPROJECMANU,
                        IDVOLUNEGOCIO,
                        CDGRUPPROD";  
                    }                
                };
                if($pagina == "FATURAMENTO"){
                    $colunasin = $colunasin.",PA.IDDTAPURFAT,
                    PA.IDEXIBEANARENTAB,
                    PA.IDGERROPFOS,
                    PA.IDDETALEFET,
                    PA.IDSERVFATROP,
                    PA.IDCONSFATUDIV,
                    PA.IDTIPOCALCTAXAADM,
                    PA.IDCALCPERCENTFAT,
                    PA.IDFATUROP,
                    PA.IDCONSNFEAUTORIZA,
                    PA.IDLANCIMPPAG,
                    PA.IDCALCIMPFAT,
                    PA.IDPERCFIXIMPREC,
                    PA.VRPERIMPRECUROP,
                    PA.IDPERFIXCALCIMP";
                    
                    $colunas = $colunas.",IDDTAPURFAT,
                    IDEXIBEANARENTAB,
                    IDGERROPFOS,
                    IDDETALEFET,
                    IDSERVFATROP,
                    IDCONSFATUDIV,
                    IDTIPOCALCTAXAADM,
                    IDCALCPERCENTFAT,
                    IDFATUROP,
                    IDCONSNFEAUTORIZA,
                    IDLANCIMPPAG,
                    IDCALCIMPFAT,
                    IDPERCFIXIMPREC,
                    VRPERIMPRECUROP,
                    IDPERFIXCALCIMP";
                    
                    $this->service->imposto($nrlistaUnidade,$params);
                    $this->service->FaturamentoBruto($nrlistaUnidade,$params);
                };
                if($pagina == "CONSUMO"){
                $colunasin = $colunasin. 
                    ",PA.IDRETIRADAROP,
                    PA.IDSERVRETROP";
                $colunas = $colunas.
                    ",IDRETIRADAROP,
                    IDSERVRETROP";
                    
                $this->service->lancamento($nrlistaUnidade,$params);
                    
                };
                if($pagina == "ESTOQUE"){
                    $colunas = $colunas.",IDINVINICROP,
                    IDIMPLANTROP,
                    IDINVFINAROP,
                    IDAJUSTEROP,
                    IDPERCONSROP,
                    NRMESCONSROP,
                    IDNRDIASUTEST,
                    IDCOMPRAROP,
                    IDNFSAIDAROP";
                    
                    $colunasin = $colunasin.",PA.IDINVINICROP,
                    PA.IDIMPLANTROP,
                    PA.IDINVFINAROP,
                    PA.IDAJUSTEROP,
                    PA.IDPERCONSROP,
                    PA.NRMESCONSROP,
                    PA.IDNRDIASUTEST,
                    PA.IDCOMPRAROP,
                    PA.IDNFSAIDAROP";
                    
                    $this->service->TipoOperacao($nrlistaUnidade,$params);
                    $this->service->NivelProduto($nrlistaUnidade,$params);
                    $this->service->saidaDevolucao($nrlistaUnidade,$params);
                    $this->service->impostoEstoque($nrlistaUnidade,$params);
                    
                    
                };
                if($pagina == "DESPESA"){
                    
                    $colunas = $colunas. 
                        ",IDDTAPUCTPAGAR,
                        IDEXIBEDESPESAMOBRA,
                        IDAPURDEPRECROP,
                        IDTIPODEPRECROP,
                        IDTPVRCTPAGAR,
                        IDDESPMOBROP,
                        IDDESPDIVROP,
                        IDAPUINVFILROP,
                        CDGRUPDESP,
                        IDDESPENTROP,
                        IDCONSPERRATFIL,
                        IDAPURDESPENTRMO,
                        IDCONSRATENTRMO,
                        IDAPUCTPGROP,
                        IDDESPMOBROPCTB,
                        IDAPUMOCTPGROP,
                        IDAPURAINVCTPAGROP,
                        IDCONSLANCAJUSPAG,
                        IDCONSLANCAJUSREC,
                        IDCONSCREDBCO,
                        IDCONSDEBBCO";
                        
                    $colunasin = $colunasin.
                       ",PA.IDDTAPUCTPAGAR,
                       PA.IDEXIBEDESPESAMOBRA,
                       PA.IDAPURDEPRECROP,
                       PA.IDTIPODEPRECROP,
                       PA.IDTPVRCTPAGAR,
                       PA.IDDESPMOBROP,
                       PA.IDDESPDIVROP,
                       PA.IDAPUINVFILROP,
                       PA.CDGRUPDESP,
                       PA.IDDESPENTROP,
                       PA.IDCONSPERRATFIL,
                       PA.IDAPURDESPENTRMO,
                       PA.IDCONSRATENTRMO,
                       PA.IDAPUCTPGROP,
                       PA.IDDESPMOBROPCTB,
                       PA.IDAPUMOCTPGROP,
                       PA.IDAPURAINVCTPAGROP,
                       PA.IDCONSLANCAJUSPAG,
                       PA.IDCONSLANCAJUSREC,
                       PA.IDCONSCREDBCO,
                       PA.IDCONSDEBBCO";
                       
                    $this->service->lancamentoDeDebito($nrlistaUnidade,$params);
                    $this->service->lancamentoDeCredito($nrlistaUnidade,$params);
                    $this->service->lancamentoDeAjuste($nrlistaUnidade,$params);
                    $this->service->contasPagar($nrlistaUnidade,$params);
                    $this->service->TipoOperacaoDespessa($nrlistaUnidade,$params);
                    $this->service->NivelProdutoDespesa($nrlistaUnidade,$params);
                    $this->service->lancamentoDeAjusteReceber($nrlistaUnidade,$params);
                };
                if($pagina == "DEDUCOES"){
                    $colunas = $colunas. 
                    ",IDEXIBEBENEFDEDU,
                    IDEXIBENUMNFDEDU,
                    IDDATADEVOLROP";
                    
                    $colunasin = $colunasin.
                    ",PA.IDEXIBEBENEFDEDU,
                    PA.IDEXIBENUMNFDEDU,
                    PA.IDDATADEVOLROP";
                     $this->service->DescontoVendas($nrlistaUnidade,$params);
                    
                };
                if($pagina == "ESPECIFICODRF"){
                    
                    $colunas = $colunas. 
                    ",CDGRUPPRODDRL,
                    CDGRUPPRODVEN,
                    IDPERFIXIMPDRF,
                    NRMETROFILIAL";
                    
                    $colunasin = $colunasin.
                    ",PA.CDGRUPPRODDRL,
                    PA.CDGRUPPRODVEN,
                    PA.IDPERFIXIMPDRF,
                    PA.NRMETROFILIAL";
                    
                    $this->service->especificoDRF($nrlistaUnidade,$params);
                };
            }
            
            $this->service->replica($nrlistaUnidade, $colunas, $params,$colunasin);
            if($nrlistaUnidade != 'T'){
                 $this->service->deleteLista($nrlistaUnidade);
            }
            
        }catch(\Exception $ex){
            $response->setError(new Error("Nao foi possivel processar os dados enviados   --- " . $ex->getMessage(), 500));
        }

    }
     public function criarListaValores($valores){
        $this->entityManager->beginTransaction();
        $lista = explode('_',$valores);
        $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrorgTrab(), 1, 10, false);
        try{
            foreach($lista as $key){
                $this->service->insertLista($nrlista, $key);
            }
            $this->entityManager->commit();
            return "_NRLISTA=".$nrlista;
        } catch(\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
    }
   
    
}





