<?php
namespace Services;

 use Zeedhi\Framework\DataSource\DataSet;
 use Zeedhi\Framework\DTO;


class Ger80200ReplicaService {
    protected $connection;
    protected $newCode;
    
    public function __construct($entityManager, $environment, $newCode){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
        $this->newCode = $newCode;
    }
    
    public function replica($nrlistaUnidade, $coluna, $params, $colunasin){
        if($nrlistaUnidade != 'T'){
            $query = "update PARFILIALROP
            set ($coluna) = (select $coluna from PARFILIALROP where CDFILIAL = :P_CDFILIAL)
            where CDFILIAL IN (SELECT CDLISTA FROM LISTA WHERE  NRLISTA = :P_NRLISTA ) AND :P_CDOPERULTATU = :P_CDOPERULTATU";
        }else{
            $query = "update PARFILIALROP
            set ($coluna) = (select $coluna from PARFILIALROP where CDFILIAL = :P_CDFILIAL)
            where CDFILIAL IN ( SELECT 'P' cdfilial FROM DUAL where :p_cdfilial <> 'P' UNION SELECT FO.CDFILIAL FROM FILIOPER FO WHERE FO.CDOPERADOR = :P_CDOPERADOR) AND :P_CDOPERULTATU = :P_CDOPERULTATU";
        }
        
        if($nrlistaUnidade != 'T'){
            
           $queryincert= "INSERT INTO PARFILIALROP (
                            CDFILIAL,
                            $coluna
                            )  
                            SELECT
                                (L.CDLISTA) CDFILIAL,
                                $colunasin
                            FROM
                                PARFILIALROP PA, 
                                LISTA L
                            WHERE
                                L.NRLISTA = :P_NRLISTA AND 
                                    PA.CDFILIAL =TO_CHAR(:P_CDFILIAL)
                                AND NOT EXISTS (SELECT PP.CDFILIAL FROM PARFILIALROP PP WHERE PP.CDFILIAL = L.CDLISTA)
                                AND :P_CDOPERULTATU = :P_CDOPERULTATU" ;
        }else{
             
           $queryincert= "
                        INSERT INTO parfilialrop (
                            cdfilial,
                            $coluna
                            ) SELECT
                            ( l.cdfilial ) cdfilial,
                            $colunasin
                            FROM
                            parfilialrop pa,
                            filialoperop l
                            WHERE
                                l.cdoperador =:p_cdoperador
                            AND
                                pa.cdfilial = TO_CHAR(:P_CDFILIAL)
                            AND NOT
                                EXISTS (
                                    SELECT
                                        pp.cdfilial
                                    FROM
                                        parfilialrop pp
                                    WHERE
                                        pp.cdfilial = l.cdfilial
                                    AND :P_CDOPERULTATU = :P_CDOPERULTATU
                                )" ;
        }
        
        $updatePadrao = "UPDATE PARFILIALROP SET (IDUTPADRROPFIL) = 'N' WHERE CDFILIAL = 'P' ";
        
        try {
          
            $stmt = $this->connection->prepare($query);
            $stmt->execute($params);
            $stmt = $this->connection->prepare($queryincert);
            $stmt->execute($params);
            $stmt = $this->connection->prepare($updatePadrao);
            $stmt->execute();
            // $retorno = $stmt->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
        
    }
    
     //insere lista no banco
    public function insertLista($nrlista, $cdlista) {
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista
        );
        
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
    
    //apaga lista do banco
    public function deleteLista($nrlista) {
        $params = array(
            "NRLISTA" => $nrlista
        );
        
        $sql = "DELETE FROM LISTA WHERE NRLISTA =:NRLISTA";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
    
    //apaga lista de valores recebendo string como parametro
    // public function apagarListaValores($valores){
    //     try{
    //         if(substr($valores, 0,9) == "_NRLISTA="){
    //             $nrlista = substr($valores, 9);
    //             $this->deleteLista($nrlista);
    //         }
    //     } catch(\Exception $e){
    //         throw $e;
    //     }
    // }

     public function imposto ($nrlistaUnidade, $params){
        
         if($nrlistaUnidade == 'T'){
            $delete = "DELETE FROM IMPOSTOROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU  AND IDTPIMPOSTOROP <> 'CC' ";
            $quary = "INSERT INTO IMPOSTOROP ( CDFILIAL, CDIMPOSTO, IDTPIMPOSTOROP, IDTRATIMPROP, DTULTATUIMRO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, VRPERFIXCALCIMP ) SELECT B.CDFILIAL, A.CDIMPOSTO, A.IDTPIMPOSTOROP, A.IDTRATIMPROP, A.DTULTATUIMRO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU, A.VRPERFIXCALCIMP FROM IMPOSTOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND A.IDTPIMPOSTOROP <> 'CC'";
            $delete_tipopagimprop = "DELETE FROM TIPOPAGIMPROP WHERE CDFILIAL <>:P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $quary_tipopagimprop = "INSERT INTO TIPOPAGIMPROP ( cdfilial, CDTPCTPAGAR, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRTIPOPAGIMPO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) SELECT b.cdfilial, A.CDTPCTPAGAR, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, :P_NRTIPOPAGIMPO+ROWNUM-1, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOPAGIMPROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') b WHERE b.cdfilial <>:p_cdfilial AND b.cdoperador =:p_cdoperador";
            $numlinhas = " SELECT COUNT(B.CDFILIAL) NUMLINHA FROM TIPOPAGIMPROP A  CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU";
         }else{
            $delete = "DELETE FROM IMPOSTOROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU AND IDTPIMPOSTOROP <> 'CC'  ";
            $quary = "INSERT INTO IMPOSTOROP ( CDFILIAL, CDIMPOSTO, IDTPIMPOSTOROP, IDTRATIMPROP, DTULTATUIMRO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, VRPERFIXCALCIMP ) SELECT B.CDFILIAL, A.CDIMPOSTO, A.IDTPIMPOSTOROP, A.IDTRATIMPROP, A.DTULTATUIMRO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU, A.VRPERFIXCALCIMP FROM IMPOSTOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL AND A.IDTPIMPOSTOROP <> 'CC'";
            $delete_tipopagimprop = "DELETE FROM TIPOPAGIMPROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
            $quary_tipopagimprop = "INSERT INTO TIPOPAGIMPROP ( CDFILIAL, CDTPCTPAGAR, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRTIPOPAGIMPO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU ) SELECT B.CDFILIAL, A.CDTPCTPAGAR, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, :P_NRTIPOPAGIMPO+ROWNUM-1, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOPAGIMPROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL" ;
            $numlinhas = "SELECT count(B.CDFILIAL) NUMLINHA FROM TIPOPAGIMPROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
         }
         
        $stmt = $this->connection->prepare($numlinhas);
        $stmt->execute($params);
		$numdeadicionados = $stmt->fetchAll()[0]['NUMLINHA'];
        $novocodigo_tipopagimprop = array(
            "P_NRTIPOPAGIMPO" => $this->newCode->getCodeByTableName('TIPOPAGIMPROP', $this->environment->getNrorgTrab(), $numdeadicionados, 10, false)
        );
        $params_tipopagimprop = array_merge($params, $novocodigo_tipopagimprop);
       
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($quary);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($delete_tipopagimprop);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($quary_tipopagimprop);
        $stmt->execute($params_tipopagimprop);
        
       
    
     }
     public function lancamento ($nrlistaUnidade,$params){
         
         if($nrlistaUnidade == 'T'){
             $delete = "DELETE FROM OPERSEMCUSTOROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
             $insert = "INSERT INTO OPERSEMCUSTOROP ( CDTIPOOPER, IDENTRSAID, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, CDFILIAL ) SELECT A.CDTIPOOPER,A.IDENTRSAID, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU, B.CDFILIAL FROM OPERSEMCUSTOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR";
         }else{
            $delete = "DELETE FROM OPERSEMCUSTOROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
            $insert = "INSERT INTO OPERSEMCUSTOROP ( CDTIPOOPER, IDENTRSAID, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, CDFILIAL ) SELECT A.CDTIPOOPER, A.IDENTRSAID, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU, B.CDFILIAL FROM OPERSEMCUSTOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL";
         }
         
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
         
             
    }
    public function TipoOperacao ($nrlistaUnidade,$params){
         
         if($nrlistaUnidade == 'T'){
             $delete = "DELETE FROM TIPOOPERACROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPOPERACROP = 'CS' OR IDTPOPERACROP = 'CC' )";
             $insert = "INSERT INTO TIPOOPERACROP ( CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDTPOPERACROP, DTULTATUTPOR, IDCOMPFATBRUTO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU )select B.CDFILIAL, A.IDENTRSAIDOP, A.CDTIPOOPER, A.IDTPOPERACROP, A.DTULTATUTPOR, A.IDCOMPFATBRUTO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOOPERACROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND (A.IDTPOPERACROP = 'CS' OR A.IDTPOPERACROP = 'CC' )";
         }else{
            $delete = "DELETE FROM TIPOOPERACROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPOPERACROP = 'CS' OR IDTPOPERACROP = 'CC' )";
            $insert = "INSERT INTO TIPOOPERACROP ( CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDTPOPERACROP, DTULTATUTPOR, IDCOMPFATBRUTO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU )select B.CDFILIAL, A.IDENTRSAIDOP, A.CDTIPOOPER, A.IDTPOPERACROP, A.DTULTATUTPOR, A.IDCOMPFATBRUTO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOOPERACROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND (A.IDTPOPERACROP = 'CS' OR A.IDTPOPERACROP = 'CC' )";
         }
         
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
    }
    public function FaturamentoBruto ($nrlistaUnidade,$params){
         
         if($nrlistaUnidade == 'T'){
             $delete = "DELETE FROM TIPOOPERACROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPOPERACROP = 'FS' )";
             $insert = "INSERT INTO TIPOOPERACROP ( CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDTPOPERACROP, DTULTATUTPOR, IDCOMPFATBRUTO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU )select B.CDFILIAL, A.IDENTRSAIDOP, A.CDTIPOOPER, A.IDTPOPERACROP, A.DTULTATUTPOR, A.IDCOMPFATBRUTO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOOPERACROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND (A.IDTPOPERACROP = 'FS')";
         }else{
            $delete = "DELETE FROM TIPOOPERACROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPOPERACROP = 'FS' )";
            $insert = "INSERT INTO TIPOOPERACROP ( CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDTPOPERACROP, DTULTATUTPOR, IDCOMPFATBRUTO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU )select B.CDFILIAL, A.IDENTRSAIDOP, A.CDTIPOOPER, A.IDTPOPERACROP, A.DTULTATUTPOR, A.IDCOMPFATBRUTO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOOPERACROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND (A.IDTPOPERACROP = 'FS'  )";
         }
         
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
    }
     public function NivelProduto ($nrlistaUnidade,$params){
         
         if($nrlistaUnidade == 'T'){
            $delete ="DELETE FROM PRODUTOROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPPRODUTOROP = 'CO' OR IDTPPRODUTOROP = 'OX' )";
            $insert ="INSERT INTO PRODUTOROP ( CDFILIAL, CDPRODUTO, IDTPPRODUTOROP, DTULTATUPRRP, NRORG, CDOPERINCLUSAO, DTINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO, IDDTAPUDESPENTR )select B.CDFILIAL, A.CDPRODUTO, A.IDTPPRODUTOROP, A.DTULTATUPRRP, A.NRORG, :P_CDOPERULTATU, A.DTINCLUSAO, A.NRORGULTATU, :P_CDOPERULTATU, A.IDATIVO, A.IDDTAPUDESPENTR FROM PRODUTOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND (A.IDTPPRODUTOROP = 'CO' OR A.IDTPPRODUTOROP = 'OX' )";
         }else{
            $delete ="DELETE FROM PRODUTOROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPPRODUTOROP = 'CO' OR IDTPPRODUTOROP = 'OX' )";
            $insert ="INSERT INTO PRODUTOROP ( CDFILIAL, CDPRODUTO, IDTPPRODUTOROP, DTULTATUPRRP, NRORG, CDOPERINCLUSAO, DTINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO, IDDTAPUDESPENTR )select B.CDFILIAL, A.CDPRODUTO, A.IDTPPRODUTOROP, A.DTULTATUPRRP, A.NRORG,  :P_CDOPERULTATU, A.DTINCLUSAO, A.NRORGULTATU, :P_CDOPERULTATU, A.IDATIVO, A.IDDTAPUDESPENTR FROM PRODUTOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND (A.IDTPPRODUTOROP = 'CO' OR A.IDTPPRODUTOROP = 'OX' )";
         }
         
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
    }
     
     public function saidaDevolucao ($nrlistaUnidade,$params){
         if($nrlistaUnidade == 'T'){
             $delete ="DELETE FROM TIPOOPERACROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU";
             $insert ="INSERT INTO TIPOOPERACROP ( CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDTPOPERACROP, IDCOMPFATBRUTO, NRORG, DTINCLUSAO, DTULTATU, DTULTATUTPOR, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU ) SELECT B.CDFILIAL, A.IDENTRSAIDOP, A.CDTIPOOPER, A.IDTPOPERACROP, A.IDCOMPFATBRUTO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.DTULTATUTPOR, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOOPERACROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <> :P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR";
         }else{
             $delete ="DELETE FROM TIPOOPERACROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
             $insert ="INSERT INTO TIPOOPERACROP ( CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDTPOPERACROP, IDCOMPFATBRUTO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU )select B.CDFILIAL, A.IDENTRSAIDOP, A.CDTIPOOPER, A.IDTPOPERACROP, A.IDCOMPFATBRUTO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOOPERACROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL";
         }
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
    }
     public function impostoEstoque ($nrlistaUnidade,$params){
         
         if($nrlistaUnidade == 'T'){
            $delete = "DELETE FROM IMPOSTOROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU AND IDTPIMPOSTOROP = 'CC'";
            $insert = "INSERT INTO IMPOSTOROP ( CDFILIAL, CDIMPOSTO, IDTPIMPOSTOROP, IDTRATIMPROP, DTULTATUIMRO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, VRPERFIXCALCIMP ) SELECT B.CDFILIAL, A.CDIMPOSTO, A.IDTPIMPOSTOROP, A.IDTRATIMPROP, A.DTULTATUIMRO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU, A.VRPERFIXCALCIMP FROM IMPOSTOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND A.IDTPIMPOSTOROP = 'CC'";
            
         }else{
            $delete = "DELETE FROM IMPOSTOROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU AND IDTPIMPOSTOROP = 'CC'";
            $insert = "INSERT INTO IMPOSTOROP ( CDFILIAL, CDIMPOSTO, IDTPIMPOSTOROP, IDTRATIMPROP, DTULTATUIMRO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, VRPERFIXCALCIMP ) SELECT B.CDFILIAL, A.CDIMPOSTO, A.IDTPIMPOSTOROP, A.IDTRATIMPROP, A.DTULTATUIMRO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU, A.VRPERFIXCALCIMP FROM IMPOSTOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL AND A.IDTPIMPOSTOROP = 'CC'";
         }
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
    }
    
    public function lancamentoDeCredito ($nrlistaUnidade,$params){
       
      if($nrlistaUnidade == 'T'){
          $delete = "DELETE FROM LANCCREDBCOROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
          $insert = "INSERT INTO LANCCREDBCOROP (NRLANCCREDBCOROP,CDFILIAL,CDTPCREDBANC,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU) SELECT :P_NRLANCCREDBCOROP+ROWNUM-1, B.CDFILIAL, A.CDTPCREDBANC, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM LANCCREDBCOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR ";
          $numlinhas = "SELECT COUNT(B.CDFILIAL) NUMLINHA FROM LANCCREDBCOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU";
      }else{
          $delete = "DELETE FROM LANCCREDBCOROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
          $insert = "INSERT INTO LANCCREDBCOROP (NRLANCCREDBCOROP,CDFILIAL,CDTPCREDBANC,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU) SELECT :P_NRLANCCREDBCOROP+ROWNUM-1, B.CDFILIAL, A.CDTPCREDBANC, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM LANCCREDBCOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL ";
          $numlinhas = "SELECT count(B.CDFILIAL) NUMLINHA FROM LANCCREDBCOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
           
      }
      
     
      
      $stmt = $this->connection->prepare($numlinhas);
      $stmt->execute($params);
      $numdeadicionados = $stmt->fetchAll()[0]['NUMLINHA'];
       $novocodigo_nrlanccredbcorop = array(
          "P_NRLANCCREDBCOROP" => $this->newCode->getCodeByTableName('LANCCREDBCOROP', $this->environment->getNrorgTrab(), $numdeadicionados, 10, false)
      );
      $params_paraInsert = array_merge($params, $novocodigo_nrlanccredbcorop);
      $stmt = $this->connection->prepare($delete);
      $stmt->execute($params);
      $stmt = $this->connection->prepare($insert);
      $stmt->execute($params_paraInsert);
  }
  
  public function lancamentoDeDebito ($nrlistaUnidade,$params){
       
      if($nrlistaUnidade == 'T'){
          $delete = "DELETE FROM LANCDEBBCOROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
          $insert = "INSERT INTO LANCDEBBCOROP (NRLANCDEBBCOROP, CDFILIAL, CDTPDEBIBANC, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) SELECT :P_NRLANCDEBBCOROP+ROWNUM-1, B.CDFILIAL, A.CDTPDEBIBANC, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM LANCDEBBCOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR ";
          $numlinhas = "SELECT COUNT(B.CDFILIAL) NUMLINHA FROM LANCDEBBCOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU";
      }else{
          $delete = "DELETE FROM LANCDEBBCOROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
          $insert = "INSERT INTO LANCDEBBCOROP (NRLANCDEBBCOROP, CDFILIAL, CDTPDEBIBANC, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) SELECT :P_NRLANCDEBBCOROP+ROWNUM-1, B.CDFILIAL, A.CDTPDEBIBANC, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM LANCDEBBCOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL ";
          $numlinhas = "SELECT count(B.CDFILIAL) NUMLINHA FROM LANCDEBBCOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
           
      }
    
      
      $stmt = $this->connection->prepare($numlinhas);
      $stmt->execute($params);
      $numdeadicionados = $stmt->fetchAll()[0]['NUMLINHA'];
      
      $novocodigo_nrlanccredbcorop = array(
          "P_NRLANCDEBBCOROP" => $this->newCode->getCodeByTableName('LANCDEBBCOROP', $this->environment->getNrorgTrab(), $numdeadicionados, 10, false)
      );
      
      $params_paraInsert = array_merge($params, $novocodigo_nrlanccredbcorop);
      
      $stmt = $this->connection->prepare($delete);
      $stmt->execute($params);
      $stmt = $this->connection->prepare($insert);
      $stmt->execute($params_paraInsert);
  }
   public function contasPagar ($nrlistaUnidade,$params){
         
         if($nrlistaUnidade == 'T'){
            $delete = "DELETE FROM TIPOCTPAGROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $insert = "INSERT INTO TIPOCTPAGROP ( CDFILIAL,CDTPCTPAGAR,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDTPCTPAGROP,IDDTAPUCTPAGAR ) SELECT B.CDFILIAL,A.CDTPCTPAGAR,A.NRORG,A.IDATIVO,A.DTINCLUSAO,A.DTULTATU,A.NRORGINCLUSAO,:P_CDOPERULTATU,A.NRORGULTATU,:P_CDOPERULTATU,A.IDTPCTPAGROP,A.IDDTAPUCTPAGAR FROM TIPOCTPAGROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR ";
            
         }else{
            $delete = "DELETE FROM TIPOCTPAGROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $insert = "INSERT INTO TIPOCTPAGROP ( CDFILIAL,CDTPCTPAGAR,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDTPCTPAGROP,IDDTAPUCTPAGAR ) SELECT B.CDFILIAL,A.CDTPCTPAGAR,A.NRORG,A.IDATIVO,A.DTINCLUSAO,A.DTULTATU,A.NRORGINCLUSAO,:P_CDOPERULTATU,A.NRORGULTATU,:P_CDOPERULTATU,A.IDTPCTPAGROP,A.IDDTAPUCTPAGAR FROM TIPOCTPAGROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL ";
         }
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
    }
     public function lancamentoDeAjuste ($nrlistaUnidade,$params){
         
        if($nrlistaUnidade == 'T'){
            $delete = "DELETE FROM TIPOAJUSPAGROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $insert = "INSERT INTO TIPOAJUSPAGROP ( NRTIPOAJUSPAGROP,CDFILIAL,CDAJUCTPAG,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU ) SELECT :P_NRTIPOAJUSPAGROP+ROWNUM-1, B.CDFILIAL, A.CDAJUCTPAG, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOAJUSPAGROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR ";
            $numlinhas = "SELECT count(b.cdfilial) NUMLINHA FROM TIPOAJUSPAGROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') b WHERE b.cdfilial <>:p_cdfilial AND b.cdoperador =:p_cdoperador AND :P_CDOPERULTATU = :P_CDOPERULTATU";
        }else{
            $delete = "DELETE FROM TIPOAJUSPAGROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $insert = "INSERT INTO TIPOAJUSPAGROP ( NRTIPOAJUSPAGROP,CDFILIAL,CDAJUCTPAG,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU ) SELECT :P_NRTIPOAJUSPAGROP+ROWNUM-1, B.CDFILIAL, A.CDAJUCTPAG, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOAJUSPAGROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL ";
            $numlinhas = "SELECT count(B.CDFILIAL) NUMLINHA FROM TIPOAJUSPAGROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
        }
         
       
        $stmt = $this->connection->prepare($numlinhas);
        $stmt->execute($params);
		$numdeadicionados = $stmt->fetchAll()[0]['NUMLINHA'];
		 $novocodigo_nrtipoajuspagrop = array(
            "P_NRTIPOAJUSPAGROP" => $this->newCode->getCodeByTableName('TIPOAJUSPAGROP', $this->environment->getNrorgTrab(), $numdeadicionados, 10, false)
        );
        $params_paraInsert = array_merge($params, $novocodigo_nrtipoajuspagrop);
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params_paraInsert);
    }
    public function lancamentoDeAjusteReceber ($nrlistaUnidade,$params){
         
        if($nrlistaUnidade == 'T'){
            $delete = "DELETE FROM TIPOAJUSRECROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $insert = "INSERT INTO TIPOAJUSRECROP (NRTIPOAJUSRECROP, CDFILIAL, CDAJUCTREC, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU ) SELECT :P_NRTIPOAJUSRECROP+ROWNUM-1,B.CDFILIAL, A.CDAJUCTREC, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOAJUSRECROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR ";
            $numlinhas = "SELECT count(b.cdfilial) NUMLINHA FROM TIPOAJUSRECROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') b WHERE b.cdfilial <>:p_cdfilial AND b.cdoperador =:p_cdoperador AND :P_CDOPERULTATU = :P_CDOPERULTATU";
        }else{
            $delete = "DELETE FROM TIPOAJUSRECROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $insert = "INSERT INTO TIPOAJUSRECROP (NRTIPOAJUSRECROP, CDFILIAL, CDAJUCTREC, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU ) SELECT :P_NRTIPOAJUSRECROP+ROWNUM-1,B.CDFILIAL, A.CDAJUCTREC, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOAJUSRECROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL ";
            $numlinhas = "SELECT count(B.CDFILIAL) NUMLINHA FROM TIPOAJUSRECROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
        }
         
       
        $stmt = $this->connection->prepare($numlinhas);
        $stmt->execute($params);
		$numdeadicionados = $stmt->fetchAll()[0]['NUMLINHA'];
		 $novocodigo_nrtipoajuspagrop = array(
            "P_NRTIPOAJUSRECROP" => $this->newCode->getCodeByTableName('TIPOAJUSRECROP', $this->environment->getNrorgTrab(), $numdeadicionados, 10, false)
        );
        $params_paraInsert = array_merge($params, $novocodigo_nrtipoajuspagrop);
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params_paraInsert);
    }
    public function TipoOperacaoDespessa ($nrlistaUnidade,$params){
         
         if($nrlistaUnidade == 'T'){
             $delete = "DELETE FROM TIPOOPERACROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPOPERACROP = 'DE' OR IDTPOPERACROP = 'MO' )";
             $insert = "INSERT INTO TIPOOPERACROP ( CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDTPOPERACROP, DTULTATUTPOR, IDCOMPFATBRUTO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU )select B.CDFILIAL, A.IDENTRSAIDOP, A.CDTIPOOPER, A.IDTPOPERACROP, A.DTULTATUTPOR, A.IDCOMPFATBRUTO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOOPERACROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND (A.IDTPOPERACROP = 'DE' OR A.IDTPOPERACROP = 'MO' )";
         }else{
            $delete = "DELETE FROM TIPOOPERACROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPOPERACROP = 'DE' OR IDTPOPERACROP = 'MO' )";
            $insert = "INSERT INTO TIPOOPERACROP ( CDFILIAL, IDENTRSAIDOP, CDTIPOOPER, IDTPOPERACROP, DTULTATUTPOR, IDCOMPFATBRUTO, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU )select B.CDFILIAL, A.IDENTRSAIDOP, A.CDTIPOOPER, A.IDTPOPERACROP, A.DTULTATUTPOR, A.IDCOMPFATBRUTO, A.NRORG, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM TIPOOPERACROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND (A.IDTPOPERACROP = 'DE' OR A.IDTPOPERACROP = 'MO' )";
         }
         
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
    }
     public function NivelProdutoDespesa ($nrlistaUnidade,$params){
         
         if($nrlistaUnidade == 'T'){
            $delete ="DELETE FROM PRODUTOROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPPRODUTOROP <> 'CO' AND IDTPPRODUTOROP <> 'OX' )";
            $insert ="INSERT INTO PRODUTOROP ( CDFILIAL, CDPRODUTO, IDTPPRODUTOROP, DTULTATUPRRP, NRORG, CDOPERINCLUSAO, DTINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO, IDDTAPUDESPENTR )select B.CDFILIAL, A.CDPRODUTO, A.IDTPPRODUTOROP, A.DTULTATUPRRP, A.NRORG, :P_CDOPERULTATU, A.DTINCLUSAO, A.NRORGULTATU, :P_CDOPERULTATU, A.IDATIVO, A.IDDTAPUDESPENTR FROM PRODUTOROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR AND (A.IDTPPRODUTOROP <> 'CO' AND A.IDTPPRODUTOROP <> 'OX' )";
         }else{
            $delete ="DELETE FROM PRODUTOROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU AND (IDTPPRODUTOROP <> 'CO' AND IDTPPRODUTOROP <> 'OX' )";
            $insert ="INSERT INTO PRODUTOROP ( CDFILIAL, CDPRODUTO, IDTPPRODUTOROP, DTULTATUPRRP, NRORG, CDOPERINCLUSAO, DTINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO, IDDTAPUDESPENTR )select B.CDFILIAL, A.CDPRODUTO, A.IDTPPRODUTOROP, A.DTULTATUPRRP, A.NRORG,  :P_CDOPERULTATU, A.DTINCLUSAO, A.NRORGULTATU, :P_CDOPERULTATU, A.IDATIVO, A.IDDTAPUDESPENTR FROM PRODUTOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND (A.IDTPPRODUTOROP <> 'CO' AND A.IDTPPRODUTOROP <> 'OX' )";
         }
         
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params);
    }
    
    public function DescontoVendas ($nrlistaUnidade,$params){
         
        if($nrlistaUnidade == 'T'){
            $delete = "DELETE FROM DEDURECEITAROP WHERE CDFILIAL <> :P_CDFILIAL AND :P_CDOPERADOR = :P_CDOPERADOR AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $insert = "INSERT INTO DEDURECEITAROP (NRDEDURECEITAROP, CDFILIAL, CDTIPOOPER, IDENTRSAIDOP, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, CDENCARGO ) SELECT :P_NRDEDURECEITAROP+ROWNUM-1, B.CDFILIAL, A.CDTIPOOPER, A.IDENTRSAIDOP, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU, A.CDENCARGO FROM DEDURECEITAROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') B WHERE B.CDFILIAL <>:P_CDFILIAL AND B.CDOPERADOR =:P_CDOPERADOR ";
            $numlinhas = "SELECT count(b.cdfilial) NUMLINHA FROM DEDURECEITAROP A CROSS JOIN (SELECT CDFILIAL,CDOPERADOR FROM  FILIALOPEROP UNION SELECT 'P' CDFILIAL,:P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :p_cdfilial <> 'P') b WHERE b.cdfilial <>:p_cdfilial AND b.cdoperador =:p_cdoperador AND :P_CDOPERULTATU = :P_CDOPERULTATU";
        }else{
            $delete = "DELETE FROM DEDURECEITAROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU ";
            $insert = "INSERT INTO DEDURECEITAROP (NRDEDURECEITAROP, CDFILIAL, CDTIPOOPER, IDENTRSAIDOP, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, CDENCARGO) SELECT :P_NRDEDURECEITAROP+ROWNUM-1, B.CDFILIAL, A.CDTIPOOPER, A.IDENTRSAIDOP, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU, A.CDENCARGO FROM DEDURECEITAROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL ";
            $numlinhas = "SELECT count(B.CDFILIAL) NUMLINHA FROM DEDURECEITAROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA =:P_NRLISTA ) B WHERE A.CDFILIAL =:P_CDFILIAL AND :P_CDOPERULTATU = :P_CDOPERULTATU";
        }
         
       
        $stmt = $this->connection->prepare($numlinhas);
        $stmt->execute($params);
		$numdeadicionados = $stmt->fetchAll()[0]['NUMLINHA'];
		 $novocodigo_nrtipoajuspagrop = array(
            "P_NRDEDURECEITAROP" => $this->newCode->getCodeByTableName('DEDURECEITAROP', $this->environment->getNrorgTrab(), $numdeadicionados, 10, false)
        );
        $params_paraInsert = array_merge($params, $novocodigo_nrtipoajuspagrop);
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($params);
        $stmt = $this->connection->prepare($insert);
        $stmt->execute($params_paraInsert);
    }
    
    public function especificoDRF ($nrlistaUnidade,$params){
        if($nrlistaUnidade == 'T'){
            $paramsDelete = array(
                'P_CDFILIAL' => $params['P_CDFILIAL']
            );
            $delete = "DELETE FROM IMPOSTOROP WHERE CDFILIAL <> :P_CDFILIAL AND IDTPIMPOSTOROP = 'FN'";
            $insert = "INSERT INTO IMPOSTOROP (IDTPIMPOSTOROP, CDFILIAL, CDIMPOSTO, IDTRATIMPROP, VRPERFIXCALCIMP, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) SELECT DISTINCT A.IDTPIMPOSTOROP, B.CDFILIAL, A.CDIMPOSTO, A.IDTRATIMPROP, A.VRPERFIXCALCIMP, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_Cdoperultatu FROM IMPOSTOROP A CROSS JOIN ( SELECT CDFILIAL, CDOPERADOR FROM FILIALOPEROP UNION SELECT 'P' CDFILIAL, :P_CDOPERADOR AS CDOPERADOR FROM DUAL WHERE :P_CDFILIAL <> 'P' ) B WHERE B.CDFILIAL <> :P_CDFILIAL AND B.CDOPERADOR = :P_CDOPERADOR AND A.IDTPIMPOSTOROP = 'FN'";
        }else{
            $paramsDelete = array(
                'P_CDFILIAL' => $params['P_CDFILIAL'],
                'P_NRLISTA' => $params['P_NRLISTA']
            );
            $delete = "DELETE FROM IMPOSTOROP WHERE CDFILIAL IN ( SELECT CDLISTA FROM LISTA WHERE NRLISTA = :P_NRLISTA ) AND :P_CDFILIAL = :P_CDFILIAL AND IDTPIMPOSTOROP = 'FN'";
            $insert = "INSERT INTO IMPOSTOROP (IDTPIMPOSTOROP, CDFILIAL, CDIMPOSTO, IDTRATIMPROP, VRPERFIXCALCIMP, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) SELECT A.IDTPIMPOSTOROP, B.CDFILIAL, A.CDIMPOSTO, A.IDTRATIMPROP, A.VRPERFIXCALCIMP, A.NRORG, A.IDATIVO, A.DTINCLUSAO, A.DTULTATU, A.NRORGINCLUSAO, :P_CDOPERULTATU, A.NRORGULTATU, :P_CDOPERULTATU FROM IMPOSTOROP A CROSS JOIN ( SELECT CDLISTA CDFILIAL FROM LISTA WHERE NRLISTA = :P_NRLISTA ) B WHERE A.CDFILIAL = :P_CDFILIAL AND IDTPIMPOSTOROP = 'FN'";
        }
        
        $stmt = $this->connection->prepare($delete);
        $stmt->execute($paramsDelete);
        $stmtInsert = $this->connection->prepare($insert);
        $stmtInsert->execute($params);
        
    }
}


 
