/* Sistemas Integrados TECNISA
   Servios

Nome: BUSCA_ALMOX

Descrio:
   Retorna o almoxarifado do produto.
Criao:
28/07/05 - Welbert G. Moitinha 
Converso:
31/08/05 - HUdson Magno*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'BUSCA_ALMOX' AND
                 TYPE = 'FN' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP FUNCTION BUSCA_ALMOX
GO

CREATE FUNCTION BUSCA_ALMOX( @P_CDFILIAL  VARCHAR(04),
                             @P_CDLOJA    VARCHAR(06),
                             @P_CDPRODUTO VARCHAR(10))
RETURNS VARCHAR
AS
BEGIN
   DECLARE @V_IDUTILALMOX  VARCHAR(01);
   DECLARE @V_IDCTRLESTQ   VARCHAR(01);
   DECLARE @V_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_CDALMOXPROD  VARCHAR(06);

   SELECT @V_IDUTILALMOX = MAX(IDUTILALMOX),
          @V_IDCTRLESTQ = MAX(IDCTRLESTQ),
          @V_CDALMOXARIFE = MAX(CDALMOXARIFE)
   FROM
      PARAMFILIAL
   WHERE
      (CDFILIAL = @P_CDFILIAL);

   IF ((@V_IDCTRLESTQ <> 'N')AND(@V_IDUTILALMOX = 'S')) BEGIN

      SELECT @V_CDALMOXPROD = MAX(CDALMOXPRCLI)
      FROM PRODFILI PF, PRODUTO P
      WHERE PF.CDFILIAL  = @P_CDFILIAL  AND
            P.CDPRODUTO  = @P_CDPRODUTO AND
            PF.CDPRODUTO = P.CDPRODESTO;

      IF (@V_CDALMOXPROD IS NOT NULL) BEGIN
         RETURN(@V_CDALMOXPROD);
      END
      ELSE BEGIN

         SELECT @V_CDALMOXPROD = MAX(CDALMOXARIFE)
         FROM LOJA
         WHERE
            CDFILIAL = @P_CDFILIAL AND
            CDLOJA   = @P_CDLOJA;

         IF (@V_CDALMOXPROD IS NULL) BEGIN
            SET @V_CDALMOXPROD = @V_CDALMOXARIFE;
         END;

         IF (@V_CDALMOXPROD IS NULL) BEGIN
            SET @V_CDALMOXPROD = ' ';
         END;

         RETURN(@V_CDALMOXPROD);
      END;
   END
   ELSE BEGIN      
      SET @V_CDALMOXPROD = ' ';      
   END;
   RETURN(@V_CDALMOXPROD);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'BUSCA_ALMOX','5.05.007';
GO

